<template>
    <hc-card>
        <template #header>
            <div class="w-32">
                <el-select v-model="searchType" placeholder="选择搜索类型" filterable block>
                    <el-option label="字典编号" value="code" />
                    <el-option label="字典名称" value="dictValue" />
                </el-select>
            </div>
            <div class="ml-2 w-60">
                <hc-search-input v-model="searchName" placeholder="请输入关键词" @search="searchClick" />
            </div>
        </template>
        <template #extra>
            <el-button hc-btn type="primary" @click="addClick">新增</el-button>
            <el-button hc-btn type="danger" @click="delClick">删除</el-button>
        </template>
        <hc-table
            ref="tableRef" :column="tableColumn" :datas="tableData" :loading="tableLoading"
            is-check :check-style="{ width: 29 }" :index-style="{ width: 60 }"
            @selection-change="tableCheckChange"
        >
            <template #isSealed="{ row }">
                {{ row.isSealed === 1 ? '是' : '否' }}
            </template>
            <template #action="{ row }">
                <el-link type="warning" @click="editRowClick(row)">修改</el-link>
                <el-link type="primary" @click="handleRowClick(row)">配置</el-link>
                <el-link v-del-com:[delRowClick]="row" type="danger">删除</el-link>
            </template>
        </hc-table>
        <template #action>
            <hc-pages :pages="searchForm" @change="pageChange" />
        </template>

        <!-- 新增/修改 -->
        <hc-dialog v-model="isDialogShow" widths="34rem" is-footer-center :title="dialogTitle" @close="dialogClose">
            <el-form ref="formRef" :model="formModel" :rules="formRules" label-position="top" label-width="auto">
                <el-row :gutter="20">
                    <el-col :span="12">
                        <el-form-item label="字典编号：" prop="code">
                            <el-input v-model="formModel.code" clearable placeholder="请输入字典编号" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="字典名称：" prop="dictValue">
                            <el-input v-model="formModel.dictValue" clearable placeholder="请输入字典名称" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="字典备注：">
                            <el-input v-model="formModel.remark" clearable placeholder="请输入字典备注" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="12">
                        <el-form-item label="字典排序：" prop="sort">
                            <el-input-number v-model="formModel.sort" :min="1" block controls-position="right" />
                        </el-form-item>
                    </el-col>
                    <el-col :span="24">
                        <el-form-item label="字典封存：" prop="isSealed">
                            <el-radio-group v-model="formModel.isSealed">
                                <el-radio :value="1">是</el-radio>
                                <el-radio :value="0" class="ml-20px">否</el-radio>
                            </el-radio-group>
                        </el-form-item>
                    </el-col>
                </el-row>
            </el-form>
            <template #footer>
                <el-button hc-btn @click="dialogClose">取消</el-button>
                <el-button hc-btn type="primary" :loading="submitLoading" @click="dialogSubmit">提交</el-button>
            </template>
        </hc-dialog>

        <!-- 字典配置 -->
        <HcChildDictbiz v-model="isConfigDialog" :info="dictTableRow" @close="dictTableClose" />
    </hc-card>
</template>

<script setup>
import { nextTick, onActivated, ref } from 'vue'
import { arrToId, formValidate, getArrValue } from 'js-fast-way'
import HcChildDictbiz from './modules/dictbiz/dictbiz.vue'
import { HcDelMsg } from 'hc-vue3-ui'
import mainApi from '~api/system/dictbiz'

//激活
onActivated(() => {
    searchForm.value.current = 1
    getTableData()
})

//搜索表单
const searchType = ref('code')
const searchName = ref('')
const searchForm = ref({ current: 1, size: 30, total: 0 })

//搜索
const searchClick = () => {
    searchForm.value.current = 1
    getTableData()
}

//分页
const pageChange = ({ current, size }) => {
    searchForm.value.current = current
    searchForm.value.size = size
    getTableData()
}

//表格数据
const tableRef = ref(null)
const tableColumn = ref([
    { key: 'code', name: '字典编号' },
    { key: 'dictValue', name: '字典名称' },
    { key: 'isSealed', name: '封存', width: 70, align: 'center' },
    { key: 'remark', name: '字典备注' },
    { key: 'action', name: '操作', width: 120, align: 'center' },
])

//获取表格数据
const tableLoading = ref(true)
const tableData = ref([])
const getTableData = async () => {
    tableData.value = []
    tableLoading.value = true
    const form = {
        ...searchForm.value,
        total: null,
    }
    if (searchName.value) {
        form[searchType.value] = searchName.value
    }
    const { data } = await mainApi.page(form)
    tableLoading.value = false
    tableData.value = getArrValue(data?.records)
    searchForm.value.total = data?.total ?? 0
}

//表格被选择
const tableCheckKeys = ref([])
const tableCheckChange = (rows) => {
    tableCheckKeys.value = rows
}

//新增/修改 弹窗
const isDialogShow = ref(false)
const dialogTitle = ref('')

//表单
const formRef = ref(null)
const formModel = ref({})
const formRules = {
    code: {
        required: true,
        trigger: 'blur',
        message: '请输入字典编号',
    },
    dictValue: {
        required: true,
        trigger: 'blur',
        message: '请输入字典名称',
    },
    sort: {
        required: true,
        trigger: 'blur',
        message: '请输入字典排序',
    },
    isSealed: {
        required: true,
        trigger: 'blur',
        message: '请选择字典封存',
    },
}

//新增
const addClick = () => {
    dialogTitle.value = '新增业务字典'
    formModel.value = { sort: 1, isSealed: 0 }
    //显示表单弹窗
    nextTick(() => {
        isDialogShow.value = true
    })
}

//修改
const editRowClick = (row) => {
    formModel.value = {}
    dialogTitle.value = '修改业务字典'
    formModel.value = { ...row }
    //显示表单弹窗
    nextTick(() => {
        isDialogShow.value = true
    })
}

//删除
const delRowClick = async ({ item }, resolve) => {
    const { isRes } = await mainApi.del(item.id)
    resolve() //关闭弹窗
    if (!isRes) return
    window.$message.success('删除成功')
    getTableData().then()
}

//批量删除
const delClick = () => {
    const rows = tableCheckKeys.value
    if (rows.length <= 0) {
        window.$message.warning('请选择要删除的菜单')
        return false
    }
    //确认删除
    HcDelMsg(async (resolve) => {
        //发起请求
        const ids = arrToId(rows)
        const { isRes } = await mainApi.del(ids)
        resolve() //关闭弹窗的回调
        if (!isRes) return
        window.$message.success('删除成功')
        getTableData().then()
    })
}

//提交表单
const submitLoading = ref(false)
const dialogSubmit = async () => {
    const formRes = await formValidate(formRef.value)
    if (!formRes) return false
    submitLoading.value = true
    //发起请求
    const { isRes } = await mainApi.submit(formModel.value)
    submitLoading.value = false
    if (!isRes) return
    dialogClose()
    window?.$message?.success('操作成功')
    getTableData().then()
}

//关闭弹窗
const dialogClose = () => {
    isDialogShow.value = false
    submitLoading.value = false
    formModel.value = {}
}

//字典配置
const isConfigDialog = ref(false)
const dictTableRow = ref({})
const handleRowClick = (row) => {
    dictTableRow.value = row
    nextTick(() => {
        isConfigDialog.value = true
    })
}

//关闭字典配置弹窗
const dictTableClose = () => {
    isConfigDialog.value = false
}
</script>
